SystemOrganization addCategory: #'Croquet-Demo'!

TGroup subclass: #TDemoFish
	instanceVariableNames: 'target contents speed count normalMaterial overMaterial downMaterial'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-Demo'!

!TDemoFish methodsFor: 'stepping' stamp: 'ar 10/7/2004 16:31'!
chooseTarget
	target := self root frameChildren detect:[:any| any name = 'light'].
! !

!TDemoFish methodsFor: 'initialize' stamp: 'ar 1/16/2006 21:43'!
contents: cnt

	contents := cnt.
	self addChild: contents.! !

!TDemoFish methodsFor: 'accessing' stamp: 'das 10/31/2005 15:53'!
distanceTo: aFrame
	^((self globalPosition - aFrame globalPosition) * (1@0@1))length! !

!TDemoFish methodsFor: 'accessing' stamp: 'ar 1/13/2006 17:25'!
downMaterial
	^downMaterial! !

!TDemoFish methodsFor: 'accessing' stamp: 'ar 1/13/2006 17:25'!
downMaterial: aMaterial
	downMaterial := aMaterial! !

!TDemoFish methodsFor: 'events' stamp: 'ar 1/27/2006 14:21'!
eventMask

	^ EventPointerOver bitOr: EventPointerDown.! !

!TDemoFish methodsFor: 'stepping' stamp: 'das 10/31/2005 15:08'!
forward: delta
	self transformBy: (Matrix4x4 withOffset: 0@0@delta negated)! !

!TDemoFish methodsFor: 'initialize' stamp: 'ar 2/7/2006 16:57'!
initialize
	super initialize.
	overMaterial := TMaterial new.
	overMaterial color: #(1 1 0 1).
	downMaterial := TMaterial new.
	downMaterial color: #(0 0 1 1).
	normalMaterial := TMaterial new.
	normalMaterial color: #(1 1 1 1).
	speed := (1 to: 5) atRandom/5.0.
	(self future: (100 atRandom + 100))move.
! !

!TDemoFish methodsFor: 'stepping' stamp: 'das 11/14/2005 10:48'!
move
	| distanceBefore distanceAfter incSpeed |

	target ifNil:[^self].
	"Compute the incremental speed" 
	incSpeed := speed / 20.0.

	"Compute the distance to the target"
	distanceBefore := self distanceTo: target.

	"Now move..."
	self forward: incSpeed.

	"If we're far away then move faster"
	distanceBefore > 50 ifTrue:[
		self forward: 4*incSpeed.
	].

	distanceBefore > 25 ifTrue:[
		self forward: 2*incSpeed.
	].
	"If we're relatively far away, then see if
	we're running away from the target. If so,
	turn around a little so that we get back on track."
	distanceBefore > 5 ifTrue:[
		distanceAfter := self distanceTo: target.
		distanceAfter > distanceBefore ifTrue:[
			self turn: (-25 to: 25) atRandom.
		].
	].
	self turn: (-5 to: 5) atRandom.
	(self future: 200)move.
! !

!TDemoFish methodsFor: 'accessing' stamp: 'ar 1/13/2006 17:25'!
normalMaterial
	^normalMaterial! !

!TDemoFish methodsFor: 'accessing' stamp: 'ar 1/13/2006 17:25'!
normalMaterial: aMaterial
	normalMaterial := aMaterial! !

!TDemoFish methodsFor: 'accessing' stamp: 'ar 1/13/2006 17:25'!
overMaterial
	^overMaterial! !

!TDemoFish methodsFor: 'accessing' stamp: 'ar 1/13/2006 17:25'!
overMaterial: aMaterial
	overMaterial := aMaterial! !

!TDemoFish methodsFor: 'events' stamp: 'das 12/26/2005 20:51'!
pointerDown: event

	contents ifNotNil:[contents material: downMaterial.].! !

!TDemoFish methodsFor: 'events' stamp: 'das 12/22/2005 00:22'!
pointerEnter: event

	contents ifNotNil:[contents material: overMaterial.].! !

!TDemoFish methodsFor: 'events' stamp: 'ar 1/13/2006 17:24'!
pointerLeave: event 

	contents ifNotNil:[contents material: normalMaterial.].! !

!TDemoFish methodsFor: 'events' stamp: 'das 4/3/2006 19:13'!
pointerUp: event 

	contents ifNotNil:[contents material: overMaterial.].
! !

!TDemoFish methodsFor: 'accessing' stamp: 'ar 10/13/2004 11:35'!
speed
	^speed! !

!TDemoFish methodsFor: 'accessing' stamp: 'ar 10/13/2004 11:35'!
speed: aSpeed
	speed := aSpeed! !

!TDemoFish methodsFor: 'accessing' stamp: 'ar 10/13/2004 11:34'!
target
	^target! !

!TDemoFish methodsFor: 'accessing' stamp: 'das 10/31/2005 15:40'!
target: aTarget
	target := aTarget.
! !

!TDemoFish methodsFor: 'stepping' stamp: 'ar 10/13/2004 11:30'!
turn: angle
	self rotateBy: angle around: (0@1@0)! !

TGroup subclass: #TRover
	instanceVariableNames: 'wheelRays wheelRadius wheelAngle wheelBase axleLength wheels frontTurn rearTurn leftFrontPair rightFrontPair leftSide rightSide rot speed wheelRotSpeed deltaSpeed turn turnAngle turnSpeed v1 v2 v3 vlr trans lastFrameNumber body doStep'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-Demo'!

!TRover commentStamp: '<historical>' prior: 0!
TRover is the 3D rover that is used in the mars simulation.!

!TRover methodsFor: 'events' stamp: 'ar 1/27/2006 14:22'!
eventMask
	^EventKeyboard! !

!TRover methodsFor: 'initialize' stamp: 'das 2/1/2006 17:46'!
initialize

	| ray mesh |
	super initialize.
	mesh := (TLoad3DSMax new initializeWithFileName: (FileDirectory pathFromURI: 'Content/Mars/rover.ASE') scale: 0.05) frame.
	mesh translationX: 0 y:0 z:0.
	mesh collapse.
	mesh boundsDepth: 2.
	mesh initBounds.
	self addChild: mesh.
	body := (mesh find:[:frm | frm objectName = 'RoverBody']) at: 1.
	wheels := OrderedCollection new.
	wheels add: ((mesh find:[:frm | frm objectName = 'LFWheel']) at: 1).
	wheels add: ((mesh find:[:frm | frm objectName = 'LMWheel']) at: 1).
	wheels add: ((mesh find:[:frm | frm objectName = 'LRWheel']) at: 1).
	wheels add: ((mesh find:[:frm | frm objectName = 'RFWheel']) at: 1).
	wheels add: ((mesh find:[:frm | frm objectName = 'RMWheel']) at: 1).
	wheels add: ((mesh find:[:frm | frm objectName = 'RRWheel']) at: 1).
	wheelRays := OrderedCollection new.
	wheels do:[ :w | 
		w solid: false.
		ray := TRay new.
		ray downRay: true.
		ray setAutomatic: false.
		wheelRays add: ray.
		w parent addChild: ray.
	]. 
	frontTurn := OrderedCollection new.
	frontTurn add:((mesh find:[:frm | frm objectName = 'LFrtWhlAssembly']) at: 1).
	frontTurn add:((mesh find:[:frm | frm objectName = 'RFrtWhlAssembly']) at: 1).
	rearTurn := OrderedCollection new.
	rearTurn add:((mesh find:[:frm | frm objectName = 'LRearWhlAssembly']) at: 1).
	rearTurn add:((mesh find:[:frm | frm objectName = 'RRearWhlAssembly']) at: 1).
	leftFrontPair := ((mesh find:[:frm | frm objectName = 'LFrtWheelPair']) at: 1).
	rightFrontPair  := ((mesh find:[:frm | frm objectName = 'RFrtWheelPair']) at: 1).
	leftSide := OrderedCollection new.
	leftSide add:((mesh find:[:frm | frm objectName = 'LFrontWheelGroup']) at: 1).
	leftSide add:((mesh find:[:frm | frm objectName = 'LRearWheelGroup']) at: 1).
	rightSide := OrderedCollection new.
	rightSide add:((mesh find:[:frm | frm objectName = 'RFrontWheelGroup']) at: 1).
	rightSide add:((mesh find:[:frm | frm objectName = 'RRearWheelGroup']) at: 1).

	wheelRadius := (wheels at: 1)frameBox extent x/2.0.
	wheelBase := ((wheels at: 1) globalPosition - (wheels at: 3) globalPosition) length.
	axleLength :=((wheels at: 1) globalPosition - (wheels at: 4) globalPosition) length.
	speed := 0.0.
	wheelRotSpeed := 0.0.
	wheelAngle := 0.0.
	deltaSpeed := 0.1.
	turn := 0.0.
	turnAngle := 0.
	turnSpeed := 0.0.
	v1 := (wheels at: 1) globalPosition - (wheels at: 2) globalPosition.
	v2 := leftFrontPair globalPosition - (wheels at:2) globalPosition.
	v3 := leftFrontPair globalPosition - (wheels at:3) globalPosition.
	vlr := (leftSide at: 1) globalPosition - (rightSide at: 1) globalPosition.
	trans := 50.
	doStep := false.! !

!TRover methodsFor: 'events' stamp: 'das 5/9/2006 08:23'!
keyStroke: event

	| c v |
	v := event keyValue.
	c := event keyCharacter.

	(c asLowercase = $i ) ifTrue:[ "inspect current state"
		self inspect.
		].
	(v = 30 or:[ c asLowercase = $f ]) ifTrue:[ "move forward" 
		self setSpeed: (speed + deltaSpeed).
		].
	(v = 31 or:[ c asLowercase = $b ])ifTrue:[ "move backwards" 
		self setSpeed: (speed - deltaSpeed).
		].
	(v = 28 or:[ c asLowercase = $l ]) ifTrue:[ "turn left" 
		self setTurn: (turn + 1).
		].
	(v = 29 or:[ c asLowercase = $r ]) ifTrue:[ "turn right" 
		self setTurn: (turn - 1).
		].
	v = 32 ifTrue:[ "stop" 
		self stopStepping.
		].
! !

!TRover methodsFor: 'accessing' stamp: 'das 2/1/2006 17:43'!
setSpeed: spd

	speed := spd.
	speed abs < (deltaSpeed/2.0) ifTrue:[speed := 0.0. self stopStepping.]ifFalse:[ self startStepping.].
	wheelRotSpeed := (speed/wheelRadius) radiansToDegrees negated.
	self updateTurn.
! !

!TRover methodsFor: 'accessing' stamp: 'das 2/1/2006 15:14'!
setTurn: trn

	turn := trn.
	turn > 45 ifTrue:[turn := 45].
	turn < -45 ifTrue:[turn := -45].
	frontTurn do:[ :ft | ft rotationAroundY: turn.].
	rearTurn do:[ :ft | ft rotationAroundY:( turn negated)].
	self updateTurn.
! !

!TRover methodsFor: 'stepping' stamp: 'das 2/2/2006 00:48'!
startStepping

	doStep ifFalse:[
		doStep := true.
		wheelRays do:[ :wr | wr setAutomatic: true.].
		self step.
	].! !

!TRover methodsFor: 'stepping' stamp: 'das 2/2/2006 00:44'!
step
	| yloc a1 a2 dv py secs |
	doStep ifFalse:[ ^ self ].
	secs := 0.05.
	speed ~= 0.0 ifTrue:[
		wheelAngle := wheelAngle + (wheelRotSpeed * secs).
		turnAngle := turnAngle + (turnSpeed * secs).
		turnAngle > 360 ifTrue:[ turnAngle := turnAngle - 360.].
		turnAngle < 0 ifTrue:[ turnAngle := turnAngle + 360].
		wheels do:[ :w | w rotationAroundZ: wheelAngle.].
		self translation: self translation+(self globalTransform column1*speed*secs).
		self rotationAroundY: turnAngle.
		(wheelRays at:1) selectedDistance ~= Float infinity ifTrue:[
			yloc := Array ofSize: 6.
			1 to: 6 do:[:index |
				yloc at: index put: ((wheels at: index) globalPosition y) - 
					((wheelRays at: index) selectedDistance - wheelRadius).].		
			dv := v1 copy.
			dv y: (yloc at:2) -(yloc at:1).
			a1 := v1 angleTo: dv.
			dv y > v1 y ifTrue:[a1 := a1 negated].
			py := (yloc at: 2) + (v2 x * (a1 sin)) + (v2 y * (a1 cos)).
			dv := v3 copy.
			dv y: py - (yloc at: 3).
			a2 := v3 angleTo: dv.
			dv y < v3 y ifTrue:[ a2 := a2 negated].
			a1 := (a1 - a2) radiansToDegrees.
			a2 := a2 radiansToDegrees.
			leftFrontPair rotationAroundZ:  a1.
			(leftSide at: 1) rotationAroundZ: a2.
			(leftSide at: 2) rotationAroundZ: a2.

			dv := v1 copy.
			dv y: (yloc at:5) -(yloc at:4).
			a1 := v1 angleTo: dv.
			dv y > v1 y ifTrue:[a1 := a1 negated].
			py := (yloc at: 5) + (v2 x * (a1 sin)) + (v2 y * (a1 cos)).
			dv := v3 copy.
			dv y: py - (yloc at: 6).
			a2 := v3 angleTo: dv.
			dv y < v3 y ifTrue:[ a2 := a2 negated].
			a1 := (a1 - a2) radiansToDegrees.
			a2 := a2 radiansToDegrees.
			rightFrontPair rotationAroundZ:  a1.
			(rightSide at: 1) rotationAroundZ: a2.
			(rightSide at: 2) rotationAroundZ: a2.
			py := (wheelRays at: 3) selectedDistance + ((wheelRays at:6) selectedDistance)/2.0.
			self translation: (self translation - (0@(py - wheelRadius)@0)).
		].
	].
	(self future: 100) step.! !

!TRover methodsFor: 'stepping' stamp: 'das 2/1/2006 17:43'!
stopStepping

	doStep ifTrue:[
		speed := 0.0.
		wheelRotSpeed := 0.0.
		turnSpeed := 0.0.
		self updateTurn.
		doStep := false.
		wheelRays do:[ :wr | wr setAutomatic: false.].
	].! !

!TRover methodsFor: 'accessing' stamp: 'das 1/30/2003 08:34'!
turnAngle

	^ turnAngle.! !

!TRover methodsFor: 'accessing' stamp: 'das 1/30/2003 08:34'!
turnAngle: ta

	turnAngle := ta.
	self rotationAroundY: ta.! !

!TRover methodsFor: 'accessing' stamp: 'ar 1/15/2006 19:09'!
updateTurn

	| turnRadius |
	turn = 0 ifTrue:[turnSpeed := 0.] ifFalse:[
		turn > 0 ifTrue:[ turnRadius := (wheelBase/2.0) * ((90-turn) degreesToRadians tan).]
		ifFalse:[turnRadius := (wheelBase/2.0) * ((90+turn) degreesToRadians tan negated).].
		turnSpeed := (speed/turnRadius) radiansToDegrees.
	].
! !

TCube subclass: #TDragCube
	instanceVariableNames: 'norm selectedPoint baseColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-Demo'!

!TDragCube commentStamp: 'das 4/3/2006 02:33' prior: 0!
TDragCube is just a simple cube that the user can drag around on the screen parallel to the selected side.!

!TDragCube methodsFor: 'events' stamp: 'das 3/29/2006 13:27'!
eventMask

	^ EventPointerOver bitOr: EventPointerDown.! !

!TDragCube methodsFor: 'events' stamp: 'das 7/14/2006 19:30'!
pointerDown: event

	selectedPoint := event selection point.
	norm := event selection normal.
	self hilite: TButton downColor.! !

!TDragCube methodsFor: 'events' stamp: 'das 7/14/2006 19:30'!
pointerEnter: event

	self hilite: TButton overColor.! !

!TDragCube methodsFor: 'events' stamp: 'das 7/14/2006 19:32'!
pointerLeave: event

	self unhilite.! !

!TDragCube methodsFor: 'events' stamp: 'das 4/2/2006 23:37'!
pointerMove: event

	| delta  pointer |
	pointer := event makePointer.
	(pointer frame: self pickPlane: selectedPoint normal: norm) ifTrue:[
		delta := selectedPoint - pointer selectedPoint.
		self translation: self translation - delta.
	].
! !

!TDragCube methodsFor: 'events' stamp: 'das 7/14/2006 19:32'!
pointerUp: event

	self unhilite.! !

!TDragCube methodsFor: 'accessing' stamp: 'das 3/23/2006 16:47'!
setColor: bc

	| mat |

	mat := TMaterial new.
	mat color: bc.
	self material: mat.
	baseColor := bc.
! !

TPrimitive subclass: #TSierpinski
	instanceVariableNames: 'depth scale vertices normals surface1 surface2 surface3 surface4 vIndex sIndex changed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-Demo'!

!TSierpinski commentStamp: '<historical>' prior: 0!
TSierpinski generates a Sierpinski pyramid. !

!TSierpinski methodsFor: 'accessing' stamp: ''!
depth

	^ depth.! !

!TSierpinski methodsFor: 'accessing' stamp: 'ar 1/19/2006 14:13'!
depth: dp

	depth := dp.
	depth <=0 ifTrue:[depth := 1].
	changed := true.
! !

!TSierpinski methodsFor: 'events' stamp: 'ar 1/27/2006 14:22'!
eventMask
	^EventKeyboard! !

!TSierpinski methodsFor: 'initialize' stamp: 'ar 1/15/2006 16:31'!
initialize
	super initialize.	
	depth := 4.
	scale := 1.0.
	changed := true.
	self update.
	^self! !

!TSierpinski methodsFor: 'events' stamp: 'ar 1/27/2006 14:42'!
keyDown: event
	| c |
	c := event keyValue asCharacter.
	c := c asInteger - $0 asInteger.
	(c >=0 and: [c<=9]) ifTrue:[self value: c.].
! !

!TSierpinski methodsFor: 'events' stamp: 'ar 1/15/2006 16:04'!
keyStroke: event
	| c |
	c := event keyValue asCharacter.
	c := c asInteger - $0 asInteger.
	(c >=0 and: [c<=9]) ifTrue:[self value: c.].
! !

!TSierpinski methodsFor: 'render' stamp: 'bgf 5/17/2006 02:27'!
pick: pointer

	"This makes pick: less dependent on the rendering activity. 
	 It's a patch until the TPrimitive changed/update/render legacy is repaired."
	changed
		ifTrue: [self update].

	(pointer pickTriangle: (normals at: 1) 
		tri: (vertices at: 3) 
		tri: (vertices at: 2)
		tri: (vertices at: 1)) ifTrue:[ ^ true. ].

	(pointer pickTriangle: (normals at: 2) 
		tri: (vertices at: 4) 
		tri: (vertices at: 3)
		tri: (vertices at: 1)) ifTrue:[ ^ true. ].

	(pointer pickTriangle: (normals at: 3) 
		tri: (vertices at: 2) 
		tri: (vertices at: 4)
		tri: (vertices at: 1)) ifTrue:[ ^ true ].

	(pointer pickTriangle: (normals at: 4) 
		tri: (vertices at: 2) 
		tri: (vertices at: 3)
		tri: (vertices at: 4)) ifTrue:[ ^ true. ].

	^ false.! !

!TSierpinski methodsFor: 'render' stamp: 'das 1/22/2005 02:12'!
renderPrimitive: ogl

	| mode |
	changed
		ifTrue: [self update].
	mode := (ogl forceWire ifTrue:[GLLineStrip] ifFalse:[GLTriangles]).
	ogl glEnableClientState: GLVertexArray.
	ogl
		glVertexPointer: 3
		with: GLFloat
		with: 0
		with: vertices.
"	norm := (vertices
				at: (surface1 at: 1))
				cross: (vertices
						at: (surface1 at: 2)) normalized."
	ogl glNormal3fv: (normals at: 1);
		glDrawElements: mode
		with: sIndex - 1
		with: GLUnsignedInt
		with: surface1 - 1.
"	norm := (vertices
				at: (surface2 at: 1))
				cross: (vertices
						at: (surface2 at: 2)) normalized."
	ogl glNormal3fv: (normals at: 2);
		glDrawElements: mode
		with: sIndex - 1
		with: GLUnsignedInt
		with: surface2 - 1.
"	norm := (vertices
				at: (surface3 at: 1))
				cross: (vertices
						at: (surface3 at: 2)) normalized."
	ogl glNormal3fv: (normals at: 3);
		glDrawElements: mode
		with: sIndex - 1
		with: GLUnsignedInt
		with: surface3 - 1.
"	norm := (vertices
				at: (surface4 at: 1))
				cross: (vertices
						at: (surface4 at: 2)) normalized."
	ogl glNormal3fv: (normals at: 4);
		glDrawElements: mode
		with: sIndex - 1
		with: GLUnsignedInt
		with: surface4 - 1.
	ogl glDisableClientState: GLVertexArray.

! !

!TSierpinski methodsFor: 'accessing' stamp: ''!
scale

	^ scale.! !

!TSierpinski methodsFor: 'accessing' stamp: ''!
scale: sc

	scale := sc.
	changed :=  true.
	self boundsChanged.
! !

!TSierpinski methodsFor: 'initialize' stamp: ''!
split: ind depth: dp
	 | c indexArray b1 b2 b3 b4 b5 b6|
	
	0 = (dp - 1) ifTrue: [
		surface1 at: sIndex put: (ind at: 1). 
		surface1 at: sIndex+1 put: (ind at: 2). 
		surface1 at: sIndex+2 put: (ind at: 3).

		surface2 at: sIndex put: (ind at: 1).
		surface2 at: sIndex+1 put: (ind at: 3). 
		surface2 at: sIndex+2 put: (ind at: 4).

		surface3 at: sIndex put: (ind at: 1). 
		surface3 at: sIndex+1 put: (ind at: 4). 
		surface3 at: sIndex+2 put: (ind at: 2).

		surface4 at: sIndex put: (ind at: 4). 
		surface4 at: sIndex+1 put: (ind at: 3). 
		surface4 at: sIndex+2 put: (ind at: 2). 
		sIndex := sIndex+3.]
 		
	ifFalse: [
		indexArray := IntegerArray ofSize: 4.

		" Make all of the new points "
		c := ((vertices at: (ind at: 1))+(vertices at: (ind at: 2)))/2.0.
		b1 := vIndex. vertices at: vIndex put: c. vIndex := vIndex + 1.
		c := ((vertices at: (ind at: 1))+(vertices at: (ind at: 3)))/2.0.
		b2 := vIndex. vertices at: vIndex put: c. vIndex := vIndex + 1.
		c := ((vertices at: (ind at: 1))+(vertices at: (ind at: 4)))/2.0.
		b3 := vIndex. vertices at: vIndex put: c. vIndex := vIndex + 1.
		c := ((vertices at: (ind at: 2))+(vertices at: (ind at: 3)))/2.0.
		b4 := vIndex. vertices at: vIndex put: c. vIndex := vIndex + 1.
		c := ((vertices at: (ind at: 3))+(vertices at: (ind at: 4)))/2.0.
		b5 := vIndex. vertices at: vIndex put: c. vIndex := vIndex + 1.
		c := ((vertices at: (ind at: 4))+(vertices at: (ind at: 2)))/2.0.
		b6 := vIndex. vertices at: vIndex put: c. vIndex := vIndex + 1.

		indexArray at: 1 put: (ind at: 1).
		indexArray at: 2 put: b1.
		indexArray at: 3 put: b2.
		indexArray at: 4 put: b3.
		self split: indexArray depth: dp-1.

		indexArray at: 1 put: b1.
		indexArray at: 2 put: (ind at: 2).
		indexArray at: 3 put: b4.
		indexArray at: 4 put: b6.
		self split: indexArray depth: dp-1.

		indexArray at: 1 put: b2.
		indexArray at: 2 put: b4.
		indexArray at: 3 put: (ind at: 3).
		indexArray at: 4 put: b5.
		self split: indexArray depth: dp-1.

		indexArray at: 1 put: b3.
		indexArray at: 2 put: b6.
		indexArray at: 3 put: b5.
		indexArray at: 4 put: (ind at: 4).
		self split: indexArray depth: dp-1.
		]

! !

!TSierpinski methodsFor: 'initialize' stamp: 'das 5/10/2004 16:23'!
update
	| sigma h v c d n1 n2 |
	" This method gets called when anything is changed."

	surface1 := IntegerArray ofSize: 3*(4 raisedTo: (depth-1)).
	surface2 := IntegerArray ofSize: 3*(4 raisedTo: (depth-1)).
	surface3 := IntegerArray ofSize: 3*(4 raisedTo: (depth-1)).
	surface4 := IntegerArray ofSize: 3*(4 raisedTo: (depth-1)).

	sigma := 0.
	1 to: depth do:[ :i | sigma := sigma + (4 raisedTo: i)].
	vertices := Vector3Array new: 4+(6*sigma).
	
	h := (1- (0.5*0.5))sqrt.
	c := (0.5*0.5)/h.
	v := (1- ((h-c)*(h-c)))sqrt.
	d := (c*v)/h.

	vertices at: 1 put: scale * (Vector3 x: -0.5 y: d negated z: c negated).
	vertices at: 2 put: scale * (Vector3 x: 0.5 y: d negated z: c negated).
	vertices at: 3 put: scale * (Vector3 x: 0.0 y: d negated z: h-c).
	vertices at: 4 put: scale * (Vector3 x: 0.0 y: v-d z: 0.0).

	vIndex := 5.
	sIndex := 1.
	self split: #(1 2 3 4) depth: depth.

	normals := Vector3Array new: 4.

	n1 := (vertices at: (surface1 at:2)) - (vertices at: (surface1 at: 1)).
	n2 := (vertices at: (surface1 at:3)) - (vertices at: (surface1 at: 1)).
	normals at: 1 put: ((n1 cross: n2) normalized).
	n1 := (vertices at: (surface2 at:2)) - (vertices at: (surface2 at: 1)).
	n2 := (vertices at: (surface2 at:3)) - (vertices at: (surface2 at: 1)).
	normals at: 2 put:  ((n1 cross: n2) normalized).
	n1 := (vertices at: (surface3 at:2)) - (vertices at: (surface3 at: 1)).
	n2 := (vertices at: (surface3 at:3)) - (vertices at: (surface3 at: 1)).
	normals at: 3 put:  ((n1 cross: n2) normalized).
	n1 := (vertices at: (surface4 at:2)) - (vertices at: (surface4 at: 1)).
	n2 := (vertices at: (surface4 at:3)) - (vertices at: (surface4 at: 1)).
	normals at: 4 put:  ((n1 cross: n2) normalized).
	boundSphere := TBoundSphere localPosition: (Vector3 x:0.0 y:0.0 z:0.0) radius: scale*(v-d).
	boundSphere frame: self.
	self boundsChanged.
	changed := false.! !

!TSierpinski methodsFor: 'accessing' stamp: 'DPR 1/9/2004 14:05'!
value: val
	val isInteger ifTrue:[
		(val >=1 and: [val <= 7]) ifTrue: [
		self depth: val.].].
! !

Object subclass: #TSnapshot
	instanceVariableNames: 'myEventMap space globalTransform postcard form update'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-Demo'!

!TSnapshot methodsFor: 'accessing' stamp: 'ar 2/2/2006 22:57'!
bounds
	^form ifNil:[self defaultBounds] ifNotNil:[0@0 extent: form extent].! !

!TSnapshot methodsFor: 'initialize' stamp: 'ar 2/2/2006 22:51'!
defaultBounds
	^0@0 corner: 128@96! !

!TSnapshot methodsFor: 'accessing' stamp: 'ar 2/2/2006 22:45'!
form
	^form! !

!TSnapshot methodsFor: 'accessing' stamp: 'ar 5/27/2006 15:09'!
form: aForm
	self signalChanged: #formChanged from: form to: aForm.
	form := aForm.
	update := false.
! !

!TSnapshot methodsFor: 'accessing' stamp: 'ar 2/2/2006 22:45'!
globalTransform
	^globalTransform! !

!TSnapshot methodsFor: 'accessing' stamp: 'ar 2/2/2006 22:45'!
globalTransform: tfm
	globalTransform := tfm! !

!TSnapshot methodsFor: 'private' stamp: 'ar 7/8/2006 18:03'!
myEventMap
	^myEventMap! !

!TSnapshot methodsFor: 'private' stamp: 'ar 7/8/2006 18:03'!
myEventMap: aMap
	myEventMap := aMap! !

!TSnapshot methodsFor: 'accessing' stamp: 'ar 2/2/2006 23:55'!
postcard
	^postcard! !

!TSnapshot methodsFor: 'initialize' stamp: 'ar 2/2/2006 23:55'!
postcard: pc
	postcard := pc.
	update := true.! !

!TSnapshot methodsFor: 'accessing' stamp: 'ar 2/2/2006 22:45'!
space
	^space! !

!TSnapshot methodsFor: 'accessing' stamp: 'ar 2/2/2006 22:45'!
space: aSpace
	space := aSpace! !

!TSnapshot methodsFor: 'initialize' stamp: 'ar 2/2/2006 23:12'!
space: aSpace transform: tfm
	space := aSpace.
	globalTransform := tfm.
	update := true.! !

!TSnapshot methodsFor: 'accessing' stamp: 'ar 2/2/2006 23:10'!
update
	^update! !

!TSnapshot methodsFor: 'accessing' stamp: 'ar 2/2/2006 23:11'!
update: aBool
	update := aBool! !

TRectangle subclass: #TWaves
	instanceVariableNames: 'size surface force velocity fVert fHorz fDiag1 fDiag2 normals textureUV oneOverSqrtTwo envTexture matWater countDown nSteps stepping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-Demo'!

!TWaves commentStamp: '<historical>' prior: 0!
TWaves illustrates a simple cellular based wave function to simulate water. It also uses environment mapping. The #texture: message sets the base texture - what shows up under the water, and the #envTexture: message sets the environment map texture.!

!TWaves class methodsFor: 'instance creation' stamp: 'ar 9/30/2004 12:39'!
initializeWithSize: sz

^ self new initializeWithSize: sz! !

!TWaves methodsFor: 'accessing' stamp: 'das 5/19/2002 00:11'!
envTexture: et
	
	envTexture := et.! !

!TWaves methodsFor: 'events' stamp: 'ar 1/27/2006 14:22'!
eventMask

	^ EventPointerOver bitOr: EventPointerDown. 
! !

!TWaves methodsFor: 'actions' stamp: 'ar 1/15/2006 16:26'!
impulse: index
	(index >=1 and:[index <= (surface size - (size x+1))]) ifTrue:[
			surface at: index put: 2.0.
			surface at: index+1 put: 2.0.
			surface at: index + size x put: 2.0.
			surface at: index + size x + 1 put: 2.0. ].
	countDown := 300.
	stepping ifFalse:[
		stepping := true.
		self step].! !

!TWaves methodsFor: 'initialize' stamp: 'ar 1/15/2006 16:24'!
initialize
	super initialize.
	stepping := false.! !

!TWaves methodsFor: 'initialize' stamp: 'ar 2/7/2006 17:01'!
initializeWithSize: sz

	| nCell |
	size := sz.
	nCell := size x * size y.

	surface := FloatArray ofSize: nCell.
	force := FloatArray ofSize: nCell.
	velocity := FloatArray ofSize: nCell.
	fVert := FloatArray ofSize: nCell.
	fHorz := FloatArray ofSize: nCell.
	fDiag1 := FloatArray ofSize: nCell.
	fDiag2 := FloatArray ofSize: nCell.
	normals := Vector3Array ofSize: nCell.
	textureUV := Vector2Array ofSize: nCell.
	oneOverSqrtTwo := 1.0/(2.0 sqrt).
	
	matWater := TMaterial new.
	matWater ambientColor: #(0.8 0.9 0.9 0.9).
	matWater diffuseColor: #(0.8 0.9 0.9 0.9).

	aspectFixed := true.
	countDown := 0.
	nSteps := 0.0.
	^self
! !

!TWaves methodsFor: 'events' stamp: 'ar 1/15/2006 16:08'!
pointerDown: event
	"the work is done in #pointerMove:"
	self pointerMove: event.

	! !

!TWaves methodsFor: 'events' stamp: 'ar 2/1/2006 16:47'!
pointerMove: event
	" #pointerMove: determines which cell we have clicked inside of and after proper bounds checking, it adds a spring force to that cell and a few surrounding it. The #step routine then calculates the wave functions based upon this disturbance."
	| loc dx dy index |

	dx := self extent x/2.
	dy := self extent y/2.
	(loc := event selection point) ifNil:[^nil].
	loc := loc - location.

	dx := (0.5+(loc x/extent x) * size x) asInteger.
	dx = size x ifTrue:[dx := dx-1.].
	dy := (0.5+(loc y/extent y)* size y) asInteger.
	dy = size y ifTrue:[dy := dy -1].
	index := (dy*size x + dx).
	self impulse: index.! !

!TWaves methodsFor: 'render' stamp: 'ar 1/15/2006 16:21'!
renderAlpha: ogl

	| tx ty ttx tty vx vy vvx vvvx vvy tcount bcount |

" This first renders the base texture, then it renders the environment map on the disturbed surface. If the surface has not been touched in 300 cycles, we can assume that it has calmed sufficiently so that we can just re-render the rectangle with the environment map on it instead of the entire grid."
(countDown ~= 0) ifTrue:[
	envTexture ifNotNil:[envTexture enable: ogl.].
	matWater enable: ogl.
	ogl glPushAttrib: GLTextureBit;
		glTexEnvf: GLTextureEnv with: GLTextureEnvMode with: GLDecal;
		glTexGeni: GLS with: GLTextureGenMode with: GLSphereMap;
		glTexGeni: GLT with: GLTextureGenMode with: GLSphereMap;
		glEnable: GLTextureGenS;
		glEnable: GLTextureGenT.
	tx := 1.0/(size x - 1).
	ty := -1.0/(size y - 1).
	vvvx := location x - (self extent x/2.0).
	vvy := location y - (self extent y/2.0).
	vx := self extent x/(size x -1)asFloat.
	vy := self extent y/(size y -1)asFloat.
	tty := 0.0.
	tcount := 1.
	bcount := tcount+size x.
	ogl glEnable: GLNormalize.
	size y -1 timesRepeat:[
		ogl glBegin: GLTriangleStrip.
		ttx := 0.0.
		vvx := vvvx.
		size x timesRepeat:[
			ogl glTexCoord2f: ttx with: tty+ty;
				glNormal3f: (fVert at: bcount) with: (fHorz at: bcount) with: 1.0;
				glVertex3f: vvx with: vvy + vy with: (surface at: bcount);

				glTexCoord2f: ttx with: tty;
				glNormal3f: (fVert at: tcount) with: (fHorz at: tcount) with: 1.0;
				glVertex3f: vvx with: vvy with: (surface at: tcount).

			ttx := ttx + tx.
			vvx := vvx + vx.
			tcount := tcount+1.
			bcount := bcount+1.
			].
		ogl glEnd.
		tty := tty + ty.
		vvy := vvy + vy.
		].
	ogl glDisable: GLNormalize.
	matWater disable: ogl.
	ogl glPopAttrib. 
	envTexture ifNotNil:[envTexture disable: ogl.].
]ifFalse:[super renderAlpha: ogl.].
! !

!TWaves methodsFor: 'stepping' stamp: 'ar 1/15/2006 16:25'!
step
	"Calculates the wave function for the surface if countDown is non-zero. It is a simple cellular based spring function. We assume that the restoring force is based only on the difference of the z-values. Given that every action has a corresponding reaction, we need only test for delta z in three directions - down, to the right, and diagonal down and to the right. The resulting difference is added to the current cell and subtracted from the adjacent cell."

	countDown = 0 ifTrue:[
		 "stop stepping"
		stepping := false.
		^self].

	countDown := countDown-1.
	fVert replaceFrom: (size x+1) to: (fVert size) with: surface startingAt: 1.
	fVert replaceFrom: 1 to: size x with: surface startingAt: 1.
	fVert -= surface.
	fHorz replaceFrom: 2 to: (fHorz size) with: surface startingAt: 1.
	1 to: size y do:[:i | | dy |
		dy := (i-1) * size x + 1.
		fHorz at: dy put: (surface at: dy).].

	fHorz -= surface.

	fDiag1 replaceFrom: (size x + 2) to: (fDiag1 size) with: surface startingAt:1.
	fDiag1 -= surface.
	fDiag2 replaceFrom: (size x -1) to: (fDiag2 size) with: surface startingAt: 1.
	fDiag2 -= surface.

	force replaceFrom: 1 to: force size with: fVert.
	fVert replaceFrom: 1 to: (fVert size - size x) with: fVert startingAt:(size x + 1).
	force -=fVert.

	force +=fHorz.
	fHorz replaceFrom: 1 to: (fHorz size - 1) with: fHorz startingAt: 2.
	force -=fHorz.

	fDiag1 *= oneOverSqrtTwo.
	force += fDiag1.
	fDiag1 replaceFrom: 1 to: (fDiag1 size - (size x +2)) with: fDiag1 startingAt: (size x + 2).
	force -= fDiag1.

	fDiag2 *= oneOverSqrtTwo.
	force += fDiag2.
	fDiag2 replaceFrom: 1 to: (fDiag2 size - (size x -1)) with: fDiag2 startingAt: (size x - 1).
	force -= fDiag2.

	force *= 0.02.
	velocity += force.
	surface += velocity.
	surface *= 0.97.

	(self future: 40) step! !

!TWaves methodsFor: 'accessing' stamp: 'das 5/19/2002 01:45'!
texture: txtr
	super texture: txtr.
	aspect := txtr aspect.! !
